<?php

namespace App\Http\Controllers;

use Validator;
use App\User;
use App\config\maill;
use App\config\services;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Mail;
use Illuminate\Contracts\Mail\Mailer;
use Illuminate\Http\Request;
use Laravel\Lumen\Routing\Controller as BaseController;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Contracts\Encryption\DecryptException;



class MailController extends BaseController 
{

	/**
     * The request instance.
     *
     * @var \Illuminate\Http\Request
     */
    private $request;

    /**
     * Create a new controller instance.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return void
     */
    public function __construct(Request $request) {
        $this->request = $request;
    }

    public function resetPassword(Request $request){
    	$data   	= $request -> data;

		try {
		    $decrypted 		= Crypt::decrypt($data);
		    $json_encode 	= json_encode($decrypted,true);
		    $json 			= json_decode($json_encode);
			$nik 			= $json->nik;
			$key 			= $json->key;
			$pass			= $json->pass;

		    $hashNewPass = Hash::make($pass);
            $affected 	=  User::where('nik',$nik)
                        ->update(['password' => $hashNewPass,'updated_by'=> $nik]);

            if($affected == "1"){
               
            	return "Reset password succesfull";
                // return response()->json([
                // 	'hashNewPass'=> $hashNewPass,
                // 	'pass'=> $pass,
                // 	'nik'=> $nik,
                // 	'key'=> $key,
                // ]);
            }

            return "Error, Problem sending data";

		} catch (DecryptException $e) {
		    return "Error, Problem valdiation data";
		}

    	// return response()->json($data);
    }

	public function testMail(User $user){

		$this->validate($this->request, [
            'nik'     => 'required',
        ]);

		$user = User::where('nik', $this->request->input('nik'))->first();

        if (!$user) {
            return response()->json([
                'error' => 'NIK belum terdaftar'
            ]);
        }
		if (!filter_var($user->email, FILTER_VALIDATE_EMAIL)) {
			return response()->json([
				'error' => 'format email salah!'
			]);
		}
		

      
          Mail::send([], [], function($message) use ($user) {

 			$randomKey 	= $this->generateRandomString();
	        $randomPass = $this->generateRandomString();

	        $data = array(
	            "key" 				=>$randomKey,
	            "pass" 				=>$randomPass,
	            "nik" 				=>$user->nik,
			);
	        $encrypt = Crypt::encrypt($data);


	        $link = "http://payroll.padma.co.id/slipGaji_v5.4/public/resetPassword?data=$encrypt";

            $message->from(['pt.padmasoode@gmail.com']);

            $message->to([$user->email]);
			
            // $message->to(['aji.satriani@gmail.com']);
            $message->subject("Reset Password");
            $message->setBody("Dear  <b>$user->name</b> 
            					<br />
            					<br /> 
            					Password : <b>$randomPass</b>
            					<br />
            					Your password will not be actived until you click following link below
            					<br /> 
            					$link 
            					<br />
            					<br /> 
            					Best Regards,
            					<br />
            					Padma Soode", 'text/html');
        });

	 //    $data = array('name'=>"ahmad");
		// Mail::raw('Raw string email', function($msg) {
		// 	 $msg->to(['aji.satriani@gmail.com'])->subject('Laravel Basic Testing Mail');
		// 	 $msg->from(['pt.padmasoode@gmail.com']);
		// }); 
	 //    // Mail::send(['hiii'], $data, function($message) {
	 //    //     $message->to('aji.sariani@gmail.com', 'welcome')->subject('Laravel Basic Testing Mail');
	 //    //     $message->from('asssd@gmail.com','ahmad');
	 //    // });

	      // Bad Request response

			// try {
			//     $decrypted = Crypt::decrypt(Crypt::encrypt($user->email));
			// 		    return response()->json([
		 //            '1' => $decrypted
		 //        ]);
			// } catch (DecryptException $e) {
			//     return response()->json([
		 //            '2' => Crypt::encrypt($e)
		 //        ]);
			// }
			return response()->json([
	            'status' => "Sukses",
	        ]);  
	}

	private function generateRandomString($length = 6) {
    	$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
	    $charactersLength = strlen($characters);
	    $randomString = '';
	    for ($i = 0; $i < $length; $i++) {
	        $randomString .= $characters[rand(0, $charactersLength - 1)];
	    }
	    return $randomString;
	} 

}