<?php
	namespace App\Http\Controllers;

	use Illuminate\Http\Request;
	use Laravel\Lumen\Routing\Controller as BaseController;

	use Firebase\JWT\JWT;
	use App\User;
	// use App\GetDataGaji;
	use Illuminate\Support\Facades\DB;
	use Pdf;
    use Illuminate\Support\Facades\Hash;
    use Illuminate\Support\Facades\Crypt;
	class PDFController extends BaseController{


		
		
		public function DownloadPDF(Request $request){

			// return "asd";
			$token      = $request -> token;
            $tahun      = $request -> tahun;
            $bulan      = $request -> bulan;

            $decoded 	= JWT::decode($token, env('JWT_SECRET'), array('HS256'));
            $user 		= User::find($decoded->sub);

            $nik 		= $user->nik;
            $name 		= $user->name; 
            $depart		= $user->departement;            

            $dataRows = DB::select("SELECT b.* 
                       		 		FROM users a
                        			INNER JOIN data_gajis b
                        			ON a.nik = b.nik  
                        			WHERE 1 = 1
                        			AND b.nik   = '".$nik."' 
                        			AND tahun   = '".$tahun."'
                        			AND bulan   = '".$bulan."'");
            $json = array();

            $bln = $this->blnFormat($bulan);

			$html = '<html>'
						.'<body>'
						.'<table border=0 cellspacing=0 cellpadding=0 width="100%">'
							.'<tr>'
								.'<td colspan="6" style="padding-top:5px;border-top:1pt solid black;border-left:1pt solid black;border-right:1pt solid black;"></td>'
							.'</tr>'
							.'<tr>'
								.'<td style="padding-left:5px;border-left:1pt solid black;">Bagian</td>'.'<td align="center">:</td>'.'<td>'.$depart.'</td>'
								.'<td colspan="2" align="center"><b>P.T. PADMA SOODE INDONESIA</b></td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">GAJI SLIP</td>'
							.'</tr>'
							.'<tr>'
								.'<td width="4%" style="padding-left:5px;border-left:1pt solid black;">Nama</td>'.'<td  align="center" width="2%">:</td>'.'<td width="24%">'.$name.'</td>'
								.'<td width="20%" align="left">NIK : '.$nik.'</td>'
								.'<td width="20%" align="right"> RANK GAJI : 1.01</td>'
								.'<td width="30%" align="right" style="padding-right:5px;border-right:1pt solid black;">'.$bln.' '.$tahun.'</td>'
							.'</tr>'
							.'<tr>'
								.'<td colspan="6" style="border-bottom:1pt solid black;border-left:1pt solid black;border-right:1pt solid black;"></td>'
							.'</tr>'
						.'</table>'
						.'<table border=0 cellspacing=0 cellpadding=0 width="100%">'
							.'<tr>'
								.'<td colspan="8" style="border-top:1pt solid black;border-left:1pt solid black;border-right:1pt solid black;"></td>'
							.'</tr>'
							.'<tr>'
								.'<td align="center" rowspan="15"style="padding-left:5px;border-left:1pt solid black;" width="18%"><u>GAJI<u></td>'
								.'<td width="2%" align="right">1.</td>'
								.'<td width="21%">Gaji Pokok</td>'
								.'<td width="16%" align="right"> '.number_format(Crypt::decrypt($dataRows[0]->gaji_egaji), 0, ',', '.').'</td>'
								.'<td width="4%"></td>'
								.'<td width="2%" align="right">14.</td>'
								.'<td width="21%">Pot Koperasi</td>'
								.'<td width="16%" align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_ri_pot_koperasi), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">2.</td>'
								.'<td>Tunj Jabatan</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_etunj_jabtaan), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">15.</td>'
								.'<td>Pot Absensi</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_cr3_cpot_mangkir), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">3.</td>'
								.'<td>Tunj Transport</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_cr1_ctunj_transport), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">16.</td>'
								.'<td>Pot THR</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_epot_spsi), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">4.</td>'
								.'<td>Uang Makan</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_cr2_ctunj_makan), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">17.</td>'
								.'<td>Pot Koreksi (-)</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_ri_koreksi), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">5.</td>'
								.'<td>Tunj Hadir</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_cr21_ctunj_hadir), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">18.</td>'
								.'<td>Pot Uang Makan</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_cr30_cpot_uangmakan), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">6.</td>'
								.'<td>Koreksi (+)</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_ril_tunj_lain2), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">19.</td>'
								.'<td>Pot Jamsostek</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_cut_hojaminan_jkkjm), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">7.</td>'
								.'<td>Bonus</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_rl_bonus), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">20.</td>'
								.'<td>Pot BPJS 4%</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_cut_tot_jpk_j1j2), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">8.</td>'
								.'<td>THR</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_ri_thr), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">21.</td>'
								.'<td>Pot BPJS Krw 1%</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_pot_bpjs_krw), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">9.</td>'
								.'<td>Tunj Jamsostek</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_ho_jaminan_jkkjm), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">22.</td>'
								.'<td>Pot JHT</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_cut_hojaminan_jht), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">10.</td>'
								.'<td>Tunj BPJS</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_tot_jpk), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">23.</td>'
								.'<td>Pot JHT - Krw 2%</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_pot_jht_krw), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">11.</td>'
								.'<td>JHT</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_ho_jaminan_jht), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">24.</td>'
								.'<td>Pot JP</td>'
								.'<td align="right"style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_cut_jp_rp), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">12.</td>'
								.'<td>JP 2%</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_jp_rp), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">25.</td>'
								.'<td>Pot JP - Krw 1%</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_pot_jw_krw), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right" style="border-bottom:1pt solid black;">13.</td>'
								.'<td style="border-bottom:1pt solid black;">Total Lembur</td>'
								.'<td align="right" style="border-bottom:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->gaji_rc_total_lembur), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right" style="border-bottom:1pt solid black;">26.</td>'
								.'<td style="border-bottom:1pt solid black;">Pot PPH 21</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;border-bottom:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_pph21_mo), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right"></td>'
								.'<td>Jumlah Penerimaan</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->gaji_jml_penerimaan), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right"></td>'
								.'<td>Jumlah Potong</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->potongan_jml_potong), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right"></td>'
								.'<td></td>'
								.'<td align="right"></td>'
								.'<td></td>'
								.'<td colspan="2"><b>Penerimaan Bersih</b></td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;"><b>Rp '.number_format(Crypt::decrypt($dataRows[0]->penerimaan_bersih), 0, ',', '.').'</b></td>'
							.'</tr>'
							.'<tr>'
								.'<td colspan="8" style="padding-bottom:20px;border-bottom:1pt solid black;border-left:1pt solid black;border-right:1pt solid black;"></td>'
							.'</tr>'
						.'</table>'
						.'<table border=0 cellspacing=0 cellpadding=0 width="100%">'
							.'<tr>'
								.'<td colspan="9" style="border-top:1pt solid black;border-left:1pt solid black;border-right:1pt solid black;"></td>'
							.'</tr>'
							.'<tr style="padding-top:20px;">'
								.'<td align="center" rowspan="2"style="padding-left:5px;border-left:1pt solid black;" width="18%"></td>'
								.'<td align="right" width="20%">Jam Lembur</td>'
								.'<td align="center" style="border-bottom:1pt solid black;" width="8%">LB1</td>'
								.'<td align="center" style="border-bottom:1pt solid black;" width="8%">LB2</td>'
								.'<td align="center" style="border-bottom:1pt solid black;" width="8%">L1</td>'
								.'<td align="center" style="border-bottom:1pt solid black;" width="8%">L2</td>'
								.'<td align="center" style="border-bottom:1pt solid black;" width="8%">L3</td>'
								.'<td align="center" style="border-bottom:1pt solid black;" width="8%">S3</td>'
								.'<td align="center" style="border-bottom:1pt solid black;" width="8%">S3/L2</td>'
								.'<td width="6%" style="border-right:1pt solid black;"></td>'
							.'</tr>'
							.'<tr>'
								.'<td ></td>'
								.'<td align="center">'.number_format(Crypt::decrypt($dataRows[0]->lembur_lb1), 0, ',', '.').'</td>'
								.'<td align="center">'.number_format(Crypt::decrypt($dataRows[0]->lembur_lb2), 0, ',', '.').'</td>'
								.'<td align="center">'.number_format(Crypt::decrypt($dataRows[0]->lembur_l1), 0, ',', '.').'</td>'
								.'<td align="center">'.number_format(Crypt::decrypt($dataRows[0]->lembur_l2), 0, ',', '.').'</td>'
								.'<td align="center">'.number_format(Crypt::decrypt($dataRows[0]->lembur_l3), 0, ',', '.').'</td>'
								.'<td align="center">'.number_format(Crypt::decrypt($dataRows[0]->lembur_s3), 0, ',', '.').'</td>'
								.'<td align="center">'.number_format(Crypt::decrypt($dataRows[0]->lemburs3_s2), 0, ',', '.').'</td>'
								.'<td style="padding-right:5px;border-right:1pt solid black;"></td>'
							.'</tr>'
						.'</table>'
						.'<table border=0 cellspacing=0 cellpadding=0 width="100%">'
							.'<tr>'
								.'<td colspan="8" style="border-left:1pt solid black;border-right:1pt solid black;"></td>'
							.'</tr>'
							.'<tr>'
								.'<td align="center" rowspan="4"style="padding-left:5px;border-left:1pt solid black;border-bottom:1pt solid black;" width="18%">PERINCIAN LEMBUR</td>'
								.'<td width="2%" align="right">1.</td>'
								.'<td width="21%">Lembur</td>'
								.'<td width="16%" align="right">'.number_format(Crypt::decrypt($dataRows[0]->lembur_cr6_clembur), 0, ',', '.').'</td>'
								.'<td width="4%"></td>'
								.'<td width="2%" align="right">5.</td>'
								.'<td width="21%">Transport Shift</td>'
								.'<td width="16%" align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->lembur_cr10_ctrans_lbr), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">2.</td>'
								.'<td>Uang Shift</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->lembur_cr7_cuang_shift), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right">6.</td>'
								.'<td>Transport Lembur</td>'
								.'<td align="right" style="padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->lembur_cr11_cumakan), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td align="right">3.</td>'
								.'<td>Uang Makan Shift</td>'
								.'<td align="right">'.number_format(Crypt::decrypt($dataRows[0]->lembur_cr8_cumakan_sft3), 0, ',', '.').'</td>'
								.'<td></td>'
								.'<td align="right" style="border-bottom:1pt solid black;">7.</td>'
								.'<td style="border-bottom:1pt solid black;">Potongan transport</td>'
								.'<td align="right" style="border-bottom:1pt solid black;padding-right:5px;border-right:1pt solid black;">'.number_format(Crypt::decrypt($dataRows[0]->lembur_r12_cpot_transport_sft2), 0, ',', '.').'</td>'
							.'</tr>'
							.'<tr>'
								.'<td style="border-bottom:1pt solid black;" align="right">4.</td>'
								.'<td style="border-bottom:1pt solid black;">Uang Makan Lembur</td>'
								.'<td style="border-bottom:1pt solid black;"align="right">'.number_format(Crypt::decrypt($dataRows[0]->lembur_cr9_ctrans_sft), 0, ',', '.').'</td>'
								.'<td style="border-bottom:1pt solid black;"></td>'
								.'<td style="border-bottom:1pt solid black;"align="right"></td>'
								.'<td style="border-bottom:1pt solid black;">Total Lembur : </td>'
								.'<td align="right" style="padding-bottom:5px;padding-right:5px;border-right:1pt solid black;border-bottom:1pt solid black;">Rp.'.number_format(Crypt::decrypt($dataRows[0]->lembur_rc_total_lembur), 0, ',', '.').'</td>'
							.'</tr>'
						.'</table>'
						.'</body>'
					.'</html>';
				return PDF::load($html, 'A4', 'portrait')->download('my_pdf');
		}

		private function blnFormat($blnDigit){

			$bln = "";
			switch ($blnDigit) {
			 	case '1':
			 		$bln = "JANUARI";
			 		break;
			 	case '2':
			 		$bln = "FEBRUARI";
			 		break;
			 	case '3':
			 		$bln = "MARET";
			 		break;
			 	case '4':
			 		$bln = "APRIL";
			 		break;
			 	case '5':
			 		$bln = "MEI";
			 		break;
			 	case '6':
			 		$bln = "JUNI";
			 		break;
			 	case '7':
			 		$bln = "JULI";
			 		break;
			 	case '8':
			 		$bln = "AGUSTUS";
			 		break;
			 	case '9':
			 		$bln = "SEPTEMBER";
			 		break;
			 	case '10':
			 		$bln = "OKTOBER";
			 		break;
			 	case '11':
			 		$bln = "NOVEMBER";
			 		break;
			 	case '12':
			 		$bln = "DESEMBER";
			 		break;	
			 	default:
			 		// $bln = "-";
			 		break;
			} 
			return $bln;
		}
	}	
			