<?php
    namespace App\Http\Controllers;

    use Illuminate\Http\Request;
    use Laravel\Lumen\Routing\Controller as BaseController;

    use Firebase\JWT\JWT;
    use App\User;
    use App\GetDataGaji;
    use Illuminate\Support\Facades\DB;
    use Illuminate\Support\Facades\Hash;

    class TestController extends BaseController{
        

         public function uploadDataUser(Request $request){
            $token      = $request -> token;
            $data       = json_decode($request -> data,true);
            $test = array();
             foreach ($data as $datax) {
                $test[]= array(
                            "password"      => Hash::make('123456'),
                            "privilege"     =>'user',
                            "status"        =>'ACTIVE',
                            "nik"           => $datax['nik'], 
                            'name'          =>$datax['name'], 
                            'email'         =>$datax['email'], 
                            'departement'   =>$datax['departement'], 
                            'rank_gaji'     =>$datax['rank_gaji'],
                            'level'         =>$datax['level'],  

                );
            }
            try{
                User::insert($test);
                return  response()->json(['status'=>'Success']);
             }
             catch(\Exception $e){
                return  response()->json($e->getMessage());
             }
        }

        public function uploadDataGaji(Request $request){
            $token      = $request -> token;
            $data       = json_decode($request -> data,true);
            try{
                GetDataGaji::insert($data);
                return  response()->json(['status'=>'Success']);
             }
             catch(\Exception $e){
                return  response()->json($e->getMessage());
             }
        }
        public function addUser(Request $request){
            
            $nik            = $request -> nik;
            $name           = $request -> nama;
            $email          = $request -> email;
            $departement    = $request -> departement;
            $rank_gaji      = $request -> rank_gaji;
            $status         = $request -> status;
            $token          = $request -> token;
            $decoded        = JWT::decode($token, env('JWT_SECRET'), array('HS256'));
            $user           = User::find($decoded->sub);


            
            $checkUser = User::where('nik', $nik)->first();
            // $checkUser = User::()get();
            if($checkUser){
                return response()->json(['status'=> 'Nik Sudah terdaftar']);
            }
            
            

            $use = new User;

            $use->nik = $nik;
            $use->name = $name;
            $use->email = $email;
            $use->departement = $departement;
            $use->rank_gaji = $rank_gaji;
            $use->status = $status;
            $use->privilege = 'user';
            $use->password =  Hash::make('123456');
    
            if($use->save()) {
                return response()->json(['status'=> 'Success']);
            }
            else{
                return response()->json(['status'=> 'Error']);
            }
            

        }

        public function editUser(Request $request){
            
            $id             = $request -> id;
            $nik            = $request -> nik;
            $name           = $request -> nama;
            $email          = $request -> email;
            $departement    = $request -> departement;
            $rank_gaji      = $request -> rank_gaji;
            $status         = $request -> status;
            $token          = $request -> token;
            $decoded        = JWT::decode($token, env('JWT_SECRET'), array('HS256'));
            $user           = User::find($decoded->sub);

            
            $affected 	=  User::where('id',$id)
                        ->update([
                                    'nik' => $nik,
                                    'name' => $name,
                                    'email' => $email,
                                    'departement' => $departement,
                                    'rank_gaji' => $rank_gaji,
                                    'status'=> $status
                                ]); 
            if($affected == "1"){
                return response()->json(['status'=> 'Success']);
            }

             return response()->json(['status'=> 'Gagal, ada kesalahan']);
            

        }

        public function getDataUser(Request $request){

            $limit      = $request -> limit;
            $page       = $request -> page;
            $token      = $request -> token;
            


            $decoded    = JWT::decode($token, env('JWT_SECRET'), array('HS256'));
            $user       = User::find($decoded->sub);     
            $level = $user->level;
           


            $getCount = DB::select("SELECT COUNT(id) as count  FROM users
                                     WHERE privilege <> 'hrd' AND status = 'ACTIVE' AND level = '$level'");

            $count = $getCount[0]->count;
            if( $count > 0 ) { 
                $total_pages = ceil($count/$limit); 
            } 
            else { 
                $total_pages = 0; 
            } 
            
            if ($page > $total_pages) $page=$total_pages; 
            $start = $limit*$page - $limit;  
            if($start <0) $start = 0;


            // return  response()->json( $count); 

             $dataRows = DB::select("SELECT * 
                                        FROM users
                                        WHERE privilege <> 'hrd'
                                        AND status = 'ACTIVE'
                                        AND level = '$level'
                                        LIMIT $limit OFFSET $start");

            if($page == 0){
                $start = 0;
                $end = 0;
            }
            else{
                $start = 1+($limit*$page)-$limit;
                $end = $limit+($limit*$page)-$limit;
                $sisa = $end%$count;
                if($sisa !=  $end){
                    $end = $end - $sisa;
                }
                if($total_pages == 1){
                    $end = $count;
                }
            }

            $test = array();
            foreach ($dataRows as $data) {
                $test[]= array(
                            "id"               =>$data->id,
                            "nik"               =>$data->nik,
                            "name"               =>$data->name,
                            "email"               =>$data->email,
                            "departement"         =>$data->departement,
                            "rank_gaji"               =>$data->rank_gaji,
                            "status"               =>$data->status,

                );
            }

           
            $json = array(
                    "page"=>$page,
                    "total"=>$total_pages,
                    "records"=>$count,
                    "start"=>$start,
                    "end"=>$end,
                    "rows"=> $test
                    );

            return  response()->json( $json); 
        }
        
        private function rupiah($angka){
	
        	if($angka == '0' or $angka == 0){
        		return "Rp 0";
        	}

            $hasil_rupiah = "Rp " . number_format($angka,2,',','.');
            return $hasil_rupiah;
         
        }
         
        
        public function getDataGajiAll(Request $request){
            $limit      = $request -> limit;
            $page       = $request -> page;
            $token      = $request -> token;
			

			$decoded = JWT::decode($token, env('JWT_SECRET'), array('HS256'));
            $user = User::find($decoded->sub);
            $privilege = $user->privilege;     

            $level = 0 ;

            if($privilege === "fin1"){
 				$level = 1 ;
            }
            else if ($privilege === "fin2"){
				$level = 2;
            }
            else if ($privilege === "fin3"){
				$level = 3;
            }
            else if ($privilege === "fin4"){
				$level = 4;
            }
            $getCount = DB::select("SELECT COUNT(nik) as count  FROM data_gajis WHERE level = $level");

            $count = $getCount[0]->count;
            if( $count > 0 ) { 
            $total_pages = ceil($count/$limit); 
            } 
            else { 
            $total_pages = 0; 
            } 

            if ($page > $total_pages) $page=$total_pages; 
            $start = $limit*$page - $limit;  
            if($start <0) $start = 0;


            // return  response()->json( $count); 

            $dataRows = DB::select("SELECT * 
                        FROM data_gajis
                        WHERE level = $level
                        LIMIT $limit OFFSET $start");

            if($page == 0){
                $start = 0;
                $end = 0;
            }
            else{
                $start = 1+($limit*$page)-$limit;
                $end = $limit+($limit*$page)-$limit;
                $sisa = $end%$count;
                if($sisa !=  $end){
                    $end = $end - $sisa;
                }
                if($total_pages == 1){
                    $end = $count;
                }
            }

            $test = array();
            foreach ($dataRows as $data) {
                $test[]= array(
                    "nik"                         =>$data->nik,
                    "bulan"                       =>$data->bulan,
                    "tahun"                       =>$data->tahun,
                    "gaji_egaji"                  =>$this->rupiah($data->gaji_egaji),
                    "gaji_etunj_jabtaan"          =>$this->rupiah($data->gaji_etunj_jabtaan),
                    "gaji_cr1_ctunj_transport"    =>$this->rupiah($data->gaji_cr1_ctunj_transport),
                    "gaji_cr2_ctunj_makan"        =>$this->rupiah($data->gaji_cr2_ctunj_makan),
                    "gaji_cr21_ctunj_hadir"       =>$this->rupiah($data->gaji_cr21_ctunj_hadir),
                    "gaji_ril_tunj_lain2"         =>$this->rupiah($data->gaji_ril_tunj_lain2),
                    "gaji_rl_bonus"               =>$this->rupiah($data->gaji_rl_bonus),
                    "gaji_ri_thr"                 =>$this->rupiah($data->gaji_ri_thr),
                    "gaji_ho_jaminan_jkkjm"       =>$this->rupiah($data->gaji_ho_jaminan_jkkjm),
                    "gaji_tot_jpk"                =>$this->rupiah($data->gaji_tot_jpk),
                    "gaji_ho_jaminan_jht"         =>$this->rupiah($data->gaji_ho_jaminan_jht),
                    "gaji_jp_rp"                  =>$this->rupiah($data->gaji_jp_rp),
                    "gaji_rc_total_lembur"        =>$this->rupiah($data->gaji_rc_total_lembur),
                    "gaji_jml_penerimaan"         =>$this->rupiah($data->gaji_jml_penerimaan),
                    "potongan_ri_pot_koperasi"    =>$this->rupiah($data->potongan_ri_pot_koperasi),
                    "potongan_cr3_cpot_mangkir"   =>$this->rupiah($data->potongan_cr3_cpot_mangkir),
                    "potongan_epot_spsi"          =>$this->rupiah($data->potongan_epot_spsi),
                    "potongan_ri_koreksi"         =>$this->rupiah($data->potongan_ri_koreksi),    
                    "potongan_cr30_cpot_uangmakan"=>$this->rupiah($data->potongan_cr30_cpot_uangmakan),
                    "potongan_cut_hojaminan_jkkjm"=>$this->rupiah($data->potongan_cut_hojaminan_jkkjm),
                    "potongan_cut_tot_jpk_j1j2"   =>$this->rupiah($data->potongan_cut_tot_jpk_j1j2),
                    "potongan_pot_bpjs_krw"       =>$this->rupiah($data->potongan_pot_bpjs_krw),
                    "potongan_cut_hojaminan_jht"  =>$this->rupiah($data->potongan_cut_hojaminan_jht),
                    "potongan_pot_jht_krw"        =>$this->rupiah($data->potongan_pot_jht_krw),
                    "potongan_cut_jp_rp"          =>$this->rupiah($data->potongan_cut_jp_rp),
                    "potongan_pot_jw_krw"         =>$this->rupiah($data->potongan_pot_jw_krw),
                    "potongan_pph21_mo"           =>$this->rupiah($data->potongan_pph21_mo),
                    "potongan_jml_potong"         =>$this->rupiah($data->potongan_jml_potong),
                    "lembur_lb1"                  =>$this->rupiah($data->lembur_lb1),
                    "lembur_lb2"                  =>$this->rupiah($data->lembur_lb2),
                    "lembur_l1"                   =>$this->rupiah($data->lembur_l1),
                    "lembur_l2"                   =>$this->rupiah($data->lembur_l2),
                    "lembur_l3"                   =>$this->rupiah($data->lembur_l3),
                    "lembur_s3"                   =>$this->rupiah($data->lembur_s3),
                    "lemburs3_s2"                 =>$this->rupiah($data->lemburs3_s2),
                    "lembur_cr6_clembur"          =>$this->rupiah($data->lembur_cr6_clembur),
                    'lembur_cr7_cuang_shift'      =>$this->rupiah($data->lembur_cr7_cuang_shift),
                    "lembur_cr8_cumakan_sft3"     =>$this->rupiah($data->lembur_cr8_cumakan_sft3),
                    "lembur_cr9_ctrans_sft"       =>$this->rupiah($data->lembur_cr9_ctrans_sft),
                    "lembur_cr10_ctrans_lbr"      =>$this->rupiah($data->lembur_cr10_ctrans_lbr),
                    "lembur_cr11_cumakan"         =>$this->rupiah($data->lembur_cr11_cumakan),
                    "lembur_r12_cpot_transport_sft2"=>$this->rupiah($data->lembur_r12_cpot_transport_sft2),
                    "lembur_rc_total_lembur"      =>$this->rupiah($data->lembur_rc_total_lembur),
                    "penerimaan_bersih"           =>$this->rupiah($data->penerimaan_bersih),

                );
            }


            $json = array(
            "page"=>$page,
            "total"=>$total_pages,
            "records"=>$count,
            "start"=>$start,
            "end"=>$end,
            "rows"=> $test
            );

            return  response()->json( $json); 
        }
        public function getDataGaji(Request $request){

            $token      = $request -> token;
            $tahun      = $request -> tahun;
            $bulan      = $request -> bulan;

            $decoded = JWT::decode($token, env('JWT_SECRET'), array('HS256'));
            $user = User::find($decoded->sub);
            $nik = $user->nik;          

            $dataRows = DB::select("SELECT b.* 
                                    FROM users a
                                    INNER JOIN data_gajis b
                                    ON a.nik = b.nik  
                                    WHERE 1 = 1
                                    AND b.nik   = '".$nik."' 
                                    AND tahun   = '".$tahun."'
                                    AND bulan   = '".$bulan."'");
            $json = array();
            $data = array();
            foreach ($dataRows as $data) {
                $json= array(
                            "nik"                               =>$data->nik,
                            "bulan"                             =>$data->bulan,
                            "tahun"                             =>$data->tahun,
                            "path_pdf"                          =>$data->path_pdf,
                            "gaji_egaji"                        =>$data->gaji_egaji,
                            "gaji_etunj_jabtaan"                =>$data->gaji_etunj_jabtaan,
                            "gaji_cr1_ctunj_transport"          =>$data->gaji_cr1_ctunj_transport,
                            "gaji_cr2_ctunj_makan"              =>$data->gaji_cr2_ctunj_makan,
                            "gaji_cr21_ctunj_hadir"             =>$data->gaji_cr21_ctunj_hadir,
                            "gaji_ril_tunj_lain2"               =>$data->gaji_ril_tunj_lain2,
                            "gaji_rl_bonus"                     =>$data->gaji_rl_bonus,
                            "gaji_ri_thr"                       =>$data->gaji_ri_thr,
                            "gaji_ho_jaminan_jkkjm"             =>$data->gaji_ho_jaminan_jkkjm,
                            "gaji_tot_jpk"                      =>$data->gaji_tot_jpk,
                            "gaji_ho_jaminan_jht"               =>$data->gaji_ho_jaminan_jht,
                            "gaji_jp_rp"                        =>$data->gaji_jp_rp,
                            "gaji_rc_total_lembur"              =>$data->gaji_rc_total_lembur,
                            "gaji_jml_penerimaan"               =>$data->gaji_jml_penerimaan,
                            "potongan_ri_pot_koperasi"          =>$data->potongan_ri_pot_koperasi,
                            "potongan_cr3_cpot_mangkir"         =>$data->potongan_cr3_cpot_mangkir,
                            "potongan_epot_spsi"                =>$data->potongan_epot_spsi,
                            "potongan_ri_koreksi"               =>$data->potongan_ri_koreksi,
                            "potongan_cr30_cpot_uangmakan"      =>$data->potongan_cr30_cpot_uangmakan,
                            "potongan_cut_hojaminan_jkkjm"      =>$data->potongan_cut_hojaminan_jkkjm,
                            "potongan_cut_tot_jpk_j1j2"         =>$data->potongan_cut_tot_jpk_j1j2,
                            "potongan_pot_bpjs_krw"             =>$data->potongan_pot_bpjs_krw,
                            "potongan_cut_hojaminan_jht"        =>$data->potongan_cut_hojaminan_jht,
                            "potongan_pot_jht_krw"              =>$data->potongan_pot_jht_krw,
                            "potongan_cut_jp_rp"                =>$data->potongan_cut_jp_rp,
                            "potongan_pot_jw_krw"               =>$data->potongan_pot_jw_krw,
                            "potongan_pph21_mo"                 =>$data->potongan_pph21_mo,
                            "potongan_jml_potong"               =>$data->potongan_jml_potong,
                            "lembur_lb1"                        =>$data->lembur_lb1,
                            "lembur_lb2"                        =>$data->lembur_lb2,
                            "lembur_l1"                         =>$data->lembur_l1,
                            "lembur_l2"                         =>$data->lembur_l2,
                            "lembur_l3"                         =>$data->lembur_l3,
                            "lembur_s3"                         =>$data->lembur_s3,
                            "lembur_s3l2"                       =>$data->lemburs3_s2,
                            "lembur_cr6_clembur"                =>$data->lembur_cr6_clembur,
                            "lembur_cr7_cuang_shift"            =>$data->lembur_cr7_cuang_shift,
                            "lembur_cr8_cumakan_sft3"           =>$data->lembur_cr8_cumakan_sft3,
                            "lembur_cr9_ctrans_sft"             =>$data->lembur_cr9_ctrans_sft,
                            "lembur_cr10_ctrans_lbr"            =>$data->lembur_cr10_ctrans_lbr,
                            "lembur_cr11_cumakan"            	=>$data->lembur_cr11_cumakan,
                            "lembur_r12_cpot_transport_sft2"    =>$data->lembur_r12_cpot_transport_sft2,
                            "lembur_rc_total_lembur"            =>$data->lembur_rc_total_lembur,
                            "penerimaan_bersih"                 =>$data->penerimaan_bersih,
                            "created_by"                        =>$data->created_by,
                            "created_date"                      =>$data->created_date,
                            "updated_by"                        =>$data->updated_by,
                            "updated_date"                      =>$data->updated_date
                            );
            }


            return  response()->json(['data' => $json]);

        }

        public function Insesrt(Request $request){   

            $nik      = $request -> nik;
            $token      = $request -> token;

            $decoded = JWT::decode($token, env('JWT_SECRET'), array('HS256'));
            $user = User::find($decoded->sub);

            return  response()->json($user);
        
        }

        public function Insert(Request $request){    
            $nik    = $request -> nik;
            $token  = $request -> token;

            $flights = GetDataGaji::where('nik', $nik)
                ->where('tahun','2017')
                ->where('bulan','11')
                ->orderBy('id', 'desc')
                ->first();
            $flights->data;
            return  response()->json($flights);
        }

    }
?>