<?php

namespace App\Http\Middleware;

use Closure;
use Exception;
use App\User;
use Firebase\JWT\JWT;
use Firebase\JWT\ExpiredException;

class JwtMiddleware
{
    public function handle($request, Closure $next, $guard = null)
    {
        $token = $request->get('token');
        
        if(!$token) {
            // Unauthorized response if token not there
            return response()->json([
                // 'error' => 'Token not provided.'
                'error' => 'Autentikasi gagal'
            ]);
        }

        try {
            $credentials = JWT::decode($token, env('JWT_SECRET'), ['HS256']);
        } catch(ExpiredException $e) {
            return response()->json([
                // 'error' => 'Provided token is expired.'
                'error' => 'Login sudah kadaluarsa'
            ]);
        } catch(Exception $e) {
            return response()->json([
                // 'error' => 'An error while decoding token.'
                'error' => 'Error Autentikasi'
            ]);
        }

        $user = User::find($credentials->sub);

        // Now let's put the user in the request class so that you can grab it from there
        $request->auth = $user;

        return $next($request);
    }
}