<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Form Login</title>
  <style>
    body {
      font-family: Arial, sans-serif;
    }
    .container {
      max-width: 400px;
      margin: 50px auto;
      padding: 20px;
      border: 1px solid #ccc;
      border-radius: 5px;
      background-color: #f9f9f9;
    }
    .form-group {
      margin-bottom: 20px;
    }
    .form-group label {
      display: block;
      font-weight: bold;
    }
    .form-group input[type="text"], 
    .form-group input[type="password"] {
      width: 100%;
      padding: 8px;
      border: 1px solid #ccc;
      border-radius: 4px;
      box-sizing: border-box;
    }
    .form-group input[type="submit"] {
      width: 100%;
      padding: 10px;
      border: none;
      border-radius: 4px;
      background-color: #007bff;
      color: white;
      cursor: pointer;
    }
    .form-group input[type="submit"]:hover {
      background-color: #0056b3;
    }
  </style>
</head>
<body>
  <div class="container">
    <form id="resetPassForm" method="post" action="<?= URL::to('resetPass'); ?>">
      <div class="form-group">
        <label for="fname">NIK</label>
        <input type="text" id="fname" name="nik" required>
      </div>
      <div class="form-group">
        <input type="submit" id="submitBtn" value="Submit">
      </div>
    </form>
  </div>

  <!-- Include jQuery library -->
  <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>

  <script>
  $(document).ready(function() {
    $('#resetPassForm').submit(function(event) {
      event.preventDefault(); // Prevent form submission

      // Perform AJAX post request
      $.ajax({
        type: 'POST',
        url: $(this).attr('action'),
        data: $(this).serialize(), // Serialize form data
        success: function(response) {
          // Check if the response contains an error
          if (response.error) {
            // Show error alert with the error message
            alert(response.error);
          } else {
            // Show success alert with the status message
            alert(response.status);
          }
        },
        error: function(xhr, status, error) {
          // Show error alert if request fails
          alert('Error: ' + error);
        }
      });
    });
  });
</script>
</body>

</html>
